package net.metadiversity.diversity.navigator.connection;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class ConnectionDialog extends JDialog 
{
	boolean OK = false;
        
	javax.swing.JTextField      edName, edDriver, edUrl, edUser;
        javax.swing.JPasswordField  edPwd;
        
        final static int marginWidth =  10;
        final static int lableWidth  = 150;
        final static int lableHeight =  30;
        final static int inputWidth  = 300;
        final static int inputHeight =  20;
        
	public ConnectionDialog() 
        {
		this(null);
	}
	public boolean getOK()      { return OK; }
	public String getName()     { return edName.getText(); }
	public String getDriver()   { return edDriver.getText(); }
	public String getUrl()      { return edUrl.getText(); }
	public String getUser()     { return edUser.getText(); }
	public String getPwd()      
        { 
            return new String( edPwd.getPassword() ); 
        }

	public ConnectionDialog( ConnectionInfo conInfo ) 
        {
		super();
                
		setTitle( "Diversity Connection Info" );
                
		setBounds( 100, 100, 2 * marginWidth + lableWidth + inputWidth, 180 );
                
		getContentPane().setLayout( new BorderLayout() );

                //--------------------------------------------------------------
		//  Edit pane
                //--------------------------------------------------------------
		JPanel Edit = new JPanel();
                
		Edit.setLayout(null);
                
		JLabel lblName  = new JLabel( "Connection name");
		JLabel lblDriver= new JLabel( "Driver class");
		JLabel lblUrl   = new JLabel( "Database URL");
		JLabel lblUser  = new JLabel( "Database user");
		JLabel lblPwd   = new JLabel( "Database password");
                
		lblName.setBounds(      marginWidth, 10, lableWidth, lableHeight );
		lblDriver.setBounds(    marginWidth, 30, lableWidth, lableHeight );
		lblUrl.setBounds(       marginWidth, 50, lableWidth, lableHeight );
		lblUser.setBounds(      marginWidth, 70, lableWidth, lableHeight );
		lblPwd.setBounds(       marginWidth, 90, lableWidth, lableHeight );
                
		Edit.add( lblName );
		Edit.add( lblDriver );
		Edit.add( lblUrl );
		Edit.add( lblUser );
		Edit.add( lblPwd );

		edName      = new javax.swing.JTextField();
		edDriver    = new javax.swing.JTextField();
		edUrl       = new javax.swing.JTextField();
		edUser      = new javax.swing.JTextField();
		edPwd       = new javax.swing.JPasswordField();
                
		edName.setBounds(   marginWidth + lableWidth, 15, inputWidth, inputHeight );
		edDriver.setBounds( marginWidth + lableWidth, 35, inputWidth, inputHeight );
		edUrl.setBounds(    marginWidth + lableWidth, 55, inputWidth, inputHeight );
		edUser.setBounds(   marginWidth + lableWidth, 75, inputWidth, inputHeight );
		edPwd.setBounds(    marginWidth + lableWidth, 95, inputWidth, inputHeight );

                if( conInfo != null ) 
                {
                    edName.setText( conInfo.getName() );
                    edName.setEnabled(false);
                        
                    edDriver.setText(   conInfo.getDriver() );
                    edUrl.setText(      conInfo.getUrl() );
                    edUser.setText(     conInfo.getUser() );
                    edPwd.setText(      conInfo.getPwd() );
		}
		Edit.add( edName );
		Edit.add( edDriver );
		Edit.add( edUrl );
		Edit.add( edUser );
		Edit.add( edPwd );

		getContentPane().add( Edit, BorderLayout.CENTER );
                
                //--------------------------------------------------------------
		// Buttons
                //--------------------------------------------------------------
		Box Buttons = new Box(BoxLayout.X_AXIS);
		Buttons.add(Box.createGlue());
		JButton cmdOK = new JButton("OK");
		cmdOK.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {OK = true; setVisible(false);}
		});
		JButton cmdCancel = new JButton("Cancel");
		cmdCancel.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {OK = false; setVisible(false);}
		});
		Buttons.add(cmdCancel);		
		Buttons.add(Box.createHorizontalStrut(5));
		Buttons.add(cmdOK);
		getContentPane().add(Buttons, BorderLayout.SOUTH);
	}
}
