package net.metadiversity.diversity.navigator.connection;

import org.apache.log4j.Logger;

public class ConnectionInfo 
{
    static Logger logger = Logger.getLogger( ConnectionInfo.class.getName() ); 
    
    private String name;
    private String driver;
    private String url;
    private String user;
    private String pwd;

    /** Conection Info
     * @param name
     * @param driver
     * @param url
     * @param user
     * @param pwd
     */    
    public ConnectionInfo( String name, String driver, String url, String user, String pwd ) 
    {
        // logger.debug( name + " " +  driver + " " + url + " " + user + " " + pwd );
        logger.debug( name + " " +  driver + " " + url + " " + user );
	this.name   = name;
	this.driver = driver;
	this.url    = url;
	this.user   = user;
	this.pwd    = pwd;
        
	try
	{
            Class.forName( driver );
	    logger.info( "Load Driver: " + driver + " ..." );
	}
	catch( java.lang.ClassNotFoundException ee )
        {
	    logger.error( "ClassNotFoundException: " );
	    logger.error( ee.getMessage() );
	    // System.err.print( "ClassNotFoundException: " );
	    // System.err.println( ee.getMessage() );
	}
    }
    
    /** conection name
     * @return
     */    
    public String getName()     
    { 
        return name; 
    }
    /** conection Driver
     * @return
     */    
    public String getDriver()   
    { 
        return driver; 
    }
    /** Conection URL
     * @return
     */    
    public String getUrl()      
    { 
        return url; 
    }
    /** Conection user
     * @return
     */    
    public String getUser()     
    { 
        return user; 
    }
    /** Conection password
     * @return
     */    
    public String getPwd()      
    { 
        return pwd; 
    }
    public java.sql.Connection getConnection()  throws java.sql.SQLException
    {
/*
	try
	{
            Class.forName( "org.postgresql.Driver" );
	    logger.info( "Load PostgreSQL Driver..." );
	}
	catch( java.lang.ClassNotFoundException ee )
        {
	    logger.error( "ClassNotFoundException: " );
	    logger.error( ee.getMessage() );
	    System.err.print( "ClassNotFoundException: " );
	    System.err.println( ee.getMessage() );
	}
 */
        return java.sql.DriverManager.getConnection( getUrl(), getUser(), getPwd() );
    }
}
