/*
 * UbtCollectionMainFrame.java
 *
 * Created on 15. Januar 2003, 19:58
 */

package net.metadiversity.diversity.navigator.db.ub;

import org.apache.log4j.Logger;

import net.metadiversity.diversity.navigator.db.ub.collection.*;
/**
 *
 * @author  didi
 */
public class UbtCollectionMainFrame extends javax.swing.JInternalFrame //javax.swing.JFrame // 
{
    static Logger logger = Logger.getLogger( UbtCollectionMainFrame.class );
    
    UbtCollectionHeader     header;
    UbtCollectionImage      image;
    UbtCollectionTabs       tabs;
    DnDataRecordSelector    records;
    javax.swing.JPanel      bottonPanel;
    
    /** Creates a new instance of UbtCollectionMainFrame */
    public UbtCollectionMainFrame() 
    {
        super( "DiversityCollection" );        
        initComponents();
    }
    private void initComponents() 
    {
        getContentPane().setLayout( new java.awt.BorderLayout() );

        // Header
        header = new UbtCollectionHeader();
        getContentPane().add( header, java.awt.BorderLayout.NORTH );        
        // image ---------------------------------------------------------------
        image = new UbtCollectionImage();
        getContentPane().add( image, java.awt.BorderLayout.CENTER );        
        // bottom --------------------------------------------------------------
        tabs    = new UbtCollectionTabs();
        records = new DnDataRecordSelector();
        
        bottonPanel = new javax.swing.JPanel();
        bottonPanel.setLayout( new java.awt.BorderLayout() );
        bottonPanel.add( tabs, java.awt.BorderLayout.CENTER );
        bottonPanel.add( records, java.awt.BorderLayout.SOUTH );
        getContentPane().add( bottonPanel, java.awt.BorderLayout.SOUTH );

        records.addActionListener( new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                recordsActionPerformed( evt );
            }
        });
        //----------------------------------------------------------------------
        /*
        addWindowListener( new java.awt.event.WindowAdapter() 
        {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });
        */
        pack();
        try
        {
            net.metadiversity.diversity.navigator.db.ub.castor.collection.CollectionBayreuth collection = new net.metadiversity.diversity.navigator.db.ub.castor.collection.CollectionBayreuth();        
            collection.init();
            long count = collection.getCollectionSpecimenCount();
            logger.debug( "Entries : " +  count );
            records.setRecordMaxValue( count );
            // read first entry  
            records.setTabs( tabs );
            tabs.setCollection( collection );
            tabs.update( 0 );
        }
        catch ( java.lang.Exception ex )
        {
            ex.printStackTrace();
        }    
        
    }
    
    private void recordsActionPerformed(java.awt.event.ActionEvent evt) 
    {
        // Data record changed
        System.out.println( "record changed" );
    }
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) 
    {
        System.exit( 0 );
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) 
    {
        UbtCollectionMainFrame f = new UbtCollectionMainFrame();
        f.setSize( 640, 480 );
        f.pack();
        f.show();
        
        try
        {
            net.metadiversity.diversity.navigator.db.ub.castor.collection.CollectionBayreuth collection = new net.metadiversity.diversity.navigator.db.ub.castor.collection.CollectionBayreuth();        
            collection.init();
            long count = collection.getCollectionSpecimenCount();
            System.out.println( "Entries : " +  count );
            f.records.setRecordMaxValue( count );
            // read first entry  
            f.records.setTabs( f.tabs );
            f.tabs.setCollection( collection );
            f.tabs.update( 0 );
        }
        catch ( java.lang.Exception ex )
        {
            ex.printStackTrace();
        }    
    }    
}
