/*
 * This class was automatically generated with 
 * <a href="http://castor.exolab.org">Castor 0.9.3.9+</a>, using an
 * XML Schema.
 * $Id: CollectionGeography.java,v 1.1.1.1 2003/03/31 14:39:47 nik Exp $
 */

package net.metadiversity.diversity.navigator.db.ub.collection;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.io.IOException;
import java.io.Reader;
import java.io.Serializable;
import java.io.Writer;
import java.util.Date;
import org.exolab.castor.xml.*;
import org.exolab.castor.xml.MarshalException;
import org.exolab.castor.xml.ValidationException;
import org.xml.sax.ContentHandler;

/**
 * Geographical data of the locality where the specimen were
 * collected.
 * 
 * @version $Revision: 1.1.1.1 $ $Date: 2003/03/31 14:39:47 $
**/
public abstract class CollectionGeography implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Refers to ID of CollectionSpecimen (= foreign key).
    **/
    private int _collectionSpecimenID;

    /**
     * keeps track of state for field: _collectionSpecimenID
    **/
    private boolean _has_collectionSpecimenID;

    /**
     * Refers to ID of LocationIdentification (= foreign key).
    **/
    private int _localisationSystemID;

    /**
     * keeps track of state for field: _localisationSystemID
    **/
    private boolean _has_localisationSystemID;

    /**
     * Either a named location selected from a thesaurus
     * (e.g."Germany, Bavaria, Kleindingharting") or values e.g.
     * 100 - 200 m (for altitude range).
    **/
    private java.lang.String _location1;

    /**
     * Corresponding value to Location2 or ID of Thesaurus.
    **/
    private java.lang.String _location2;

    /**
     * Date of the determination of the geography.
    **/
    private java.util.Date _determinationDate;

    /**
     * Person, team or organisation responsible for the data.
    **/
    private java.lang.String _responsible;

    /**
     * Calculated altitude as parsed from the location fields.
    **/
    private double _averageAltitudeCache;

    /**
     * keeps track of state for field: _averageAltitudeCache
    **/
    private boolean _has_averageAltitudeCache;

    /**
     * Calculated longitude as parsed from the location fields.
    **/
    private double _averageLongitudeCache;

    /**
     * keeps track of state for field: _averageLongitudeCache
    **/
    private boolean _has_averageLongitudeCache;

    /**
     * Calculated latitude as parsed from the location fields.
    **/
    private double _averageLatitudeCache;

    /**
     * keeps track of state for field: _averageLatitudeCache
    **/
    private boolean _has_averageLatitudeCache;


      //----------------/
     //- Constructors -/
    //----------------/

    public CollectionGeography() {
        super();
    } //-- net.metadiversity.diversity.navigator.db.ub.collection.CollectionGeography()


      //-----------/
     //- Methods -/
    //-----------/

    /**
    **/
    public void deleteAverageAltitudeCache()
    {
        this._has_averageAltitudeCache= false;
    } //-- void deleteAverageAltitudeCache() 

    /**
    **/
    public void deleteAverageLatitudeCache()
    {
        this._has_averageLatitudeCache= false;
    } //-- void deleteAverageLatitudeCache() 

    /**
    **/
    public void deleteAverageLongitudeCache()
    {
        this._has_averageLongitudeCache= false;
    } //-- void deleteAverageLongitudeCache() 

    /**
     * Returns the value of field 'averageAltitudeCache'. The field
     * 'averageAltitudeCache' has the following description:
     * Calculated altitude as parsed from the location fields.
     * 
     * @return the value of field 'averageAltitudeCache'.
    **/
    public double getAverageAltitudeCache()
    {
        return this._averageAltitudeCache;
    } //-- double getAverageAltitudeCache() 

    /**
     * Returns the value of field 'averageLatitudeCache'. The field
     * 'averageLatitudeCache' has the following description:
     * Calculated latitude as parsed from the location fields.
     * 
     * @return the value of field 'averageLatitudeCache'.
    **/
    public double getAverageLatitudeCache()
    {
        return this._averageLatitudeCache;
    } //-- double getAverageLatitudeCache() 

    /**
     * Returns the value of field 'averageLongitudeCache'. The
     * field 'averageLongitudeCache' has the following description:
     * Calculated longitude as parsed from the location fields.
     * 
     * @return the value of field 'averageLongitudeCache'.
    **/
    public double getAverageLongitudeCache()
    {
        return this._averageLongitudeCache;
    } //-- double getAverageLongitudeCache() 

    /**
     * Returns the value of field 'collectionSpecimenID'. The field
     * 'collectionSpecimenID' has the following description: Refers
     * to ID of CollectionSpecimen (= foreign key).
     * 
     * @return the value of field 'collectionSpecimenID'.
    **/
    public int getCollectionSpecimenID()
    {
        return this._collectionSpecimenID;
    } //-- int getCollectionSpecimenID() 

    /**
     * Returns the value of field 'determinationDate'. The field
     * 'determinationDate' has the following description: Date of
     * the determination of the geography.
     * 
     * @return the value of field 'determinationDate'.
    **/
    public java.util.Date getDeterminationDate()
    {
        return this._determinationDate;
    } //-- java.util.Date getDeterminationDate() 

    /**
     * Returns the value of field 'localisationSystemID'. The field
     * 'localisationSystemID' has the following description: Refers
     * to ID of LocationIdentification (= foreign key).
     * 
     * @return the value of field 'localisationSystemID'.
    **/
    public int getLocalisationSystemID()
    {
        return this._localisationSystemID;
    } //-- int getLocalisationSystemID() 

    /**
     * Returns the value of field 'location1'. The field
     * 'location1' has the following description: Either a named
     * location selected from a thesaurus (e.g."Germany, Bavaria,
     * Kleindingharting") or values e.g. 100 - 200 m (for altitude
     * range).
     * 
     * @return the value of field 'location1'.
    **/
    public java.lang.String getLocation1()
    {
        return this._location1;
    } //-- java.lang.String getLocation1() 

    /**
     * Returns the value of field 'location2'. The field
     * 'location2' has the following description: Corresponding
     * value to Location2 or ID of Thesaurus.
     * 
     * @return the value of field 'location2'.
    **/
    public java.lang.String getLocation2()
    {
        return this._location2;
    } //-- java.lang.String getLocation2() 

    /**
     * Returns the value of field 'responsible'. The field
     * 'responsible' has the following description: Person, team or
     * organisation responsible for the data.
     * 
     * @return the value of field 'responsible'.
    **/
    public java.lang.String getResponsible()
    {
        return this._responsible;
    } //-- java.lang.String getResponsible() 

    /**
    **/
    public boolean hasAverageAltitudeCache()
    {
        return this._has_averageAltitudeCache;
    } //-- boolean hasAverageAltitudeCache() 

    /**
    **/
    public boolean hasAverageLatitudeCache()
    {
        return this._has_averageLatitudeCache;
    } //-- boolean hasAverageLatitudeCache() 

    /**
    **/
    public boolean hasAverageLongitudeCache()
    {
        return this._has_averageLongitudeCache;
    } //-- boolean hasAverageLongitudeCache() 

    /**
    **/
    public boolean hasCollectionSpecimenID()
    {
        return this._has_collectionSpecimenID;
    } //-- boolean hasCollectionSpecimenID() 

    /**
    **/
    public boolean hasLocalisationSystemID()
    {
        return this._has_localisationSystemID;
    } //-- boolean hasLocalisationSystemID() 

    /**
    **/
    public boolean isValid()
    {
        try {
            validate();
        }
        catch (org.exolab.castor.xml.ValidationException vex) {
            return false;
        }
        return true;
    } //-- boolean isValid() 

    /**
     * 
     * 
     * @param out
    **/
    public abstract void marshal(java.io.Writer out)
        throws org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException;

    /**
     * 
     * 
     * @param handler
    **/
    public abstract void marshal(org.xml.sax.ContentHandler handler)
        throws java.io.IOException, org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException;

    /**
     * Sets the value of field 'averageAltitudeCache'. The field
     * 'averageAltitudeCache' has the following description:
     * Calculated altitude as parsed from the location fields.
     * 
     * @param averageAltitudeCache the value of field
     * 'averageAltitudeCache'.
    **/
    public void setAverageAltitudeCache(double averageAltitudeCache)
    {
        this._averageAltitudeCache = averageAltitudeCache;
        this._has_averageAltitudeCache = true;
    } //-- void setAverageAltitudeCache(double) 

    /**
     * Sets the value of field 'averageLatitudeCache'. The field
     * 'averageLatitudeCache' has the following description:
     * Calculated latitude as parsed from the location fields.
     * 
     * @param averageLatitudeCache the value of field
     * 'averageLatitudeCache'.
    **/
    public void setAverageLatitudeCache(double averageLatitudeCache)
    {
        this._averageLatitudeCache = averageLatitudeCache;
        this._has_averageLatitudeCache = true;
    } //-- void setAverageLatitudeCache(double) 

    /**
     * Sets the value of field 'averageLongitudeCache'. The field
     * 'averageLongitudeCache' has the following description:
     * Calculated longitude as parsed from the location fields.
     * 
     * @param averageLongitudeCache the value of field
     * 'averageLongitudeCache'.
    **/
    public void setAverageLongitudeCache(double averageLongitudeCache)
    {
        this._averageLongitudeCache = averageLongitudeCache;
        this._has_averageLongitudeCache = true;
    } //-- void setAverageLongitudeCache(double) 

    /**
     * Sets the value of field 'collectionSpecimenID'. The field
     * 'collectionSpecimenID' has the following description: Refers
     * to ID of CollectionSpecimen (= foreign key).
     * 
     * @param collectionSpecimenID the value of field
     * 'collectionSpecimenID'.
    **/
    public void setCollectionSpecimenID(int collectionSpecimenID)
    {
        this._collectionSpecimenID = collectionSpecimenID;
        this._has_collectionSpecimenID = true;
    } //-- void setCollectionSpecimenID(int) 

    /**
     * Sets the value of field 'determinationDate'. The field
     * 'determinationDate' has the following description: Date of
     * the determination of the geography.
     * 
     * @param determinationDate the value of field
     * 'determinationDate'.
    **/
    public void setDeterminationDate(java.util.Date determinationDate)
    {
        this._determinationDate = determinationDate;
    } //-- void setDeterminationDate(java.util.Date) 

    /**
     * Sets the value of field 'localisationSystemID'. The field
     * 'localisationSystemID' has the following description: Refers
     * to ID of LocationIdentification (= foreign key).
     * 
     * @param localisationSystemID the value of field
     * 'localisationSystemID'.
    **/
    public void setLocalisationSystemID(int localisationSystemID)
    {
        this._localisationSystemID = localisationSystemID;
        this._has_localisationSystemID = true;
    } //-- void setLocalisationSystemID(int) 

    /**
     * Sets the value of field 'location1'. The field 'location1'
     * has the following description: Either a named location
     * selected from a thesaurus (e.g."Germany, Bavaria,
     * Kleindingharting") or values e.g. 100 - 200 m (for altitude
     * range).
     * 
     * @param location1 the value of field 'location1'.
    **/
    public void setLocation1(java.lang.String location1)
    {
        this._location1 = location1;
    } //-- void setLocation1(java.lang.String) 

    /**
     * Sets the value of field 'location2'. The field 'location2'
     * has the following description: Corresponding value to
     * Location2 or ID of Thesaurus.
     * 
     * @param location2 the value of field 'location2'.
    **/
    public void setLocation2(java.lang.String location2)
    {
        this._location2 = location2;
    } //-- void setLocation2(java.lang.String) 

    /**
     * Sets the value of field 'responsible'. The field
     * 'responsible' has the following description: Person, team or
     * organisation responsible for the data.
     * 
     * @param responsible the value of field 'responsible'.
    **/
    public void setResponsible(java.lang.String responsible)
    {
        this._responsible = responsible;
    } //-- void setResponsible(java.lang.String) 

    /**
    **/
    public void validate()
        throws org.exolab.castor.xml.ValidationException
    {
        org.exolab.castor.xml.Validator validator = new org.exolab.castor.xml.Validator();
        validator.validate(this);
    } //-- void validate() 

}
