/*
 * This class was automatically generated with 
 * <a href="http://castor.exolab.org">Castor 0.9.3.9+</a>, using an
 * XML Schema.
 * $Id: CollectionSpecimen.java,v 1.1.1.1 2003/03/31 14:39:47 nik Exp $
 */

package net.metadiversity.diversity.navigator.db.ub.collection;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.io.IOException;
import java.io.Reader;
import java.io.Serializable;
import java.io.Writer;
import java.util.Date;
import org.exolab.castor.xml.*;
import org.exolab.castor.xml.MarshalException;
import org.exolab.castor.xml.ValidationException;
import org.xml.sax.ContentHandler;

/**
 * Data of collection specimen.
 * 
 * @version $Revision: 1.1.1.1 $ $Date: 2003/03/31 14:39:47 $
**/
public abstract class CollectionSpecimen implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Unique reference ID for the collection record (primary key).
    **/
    private int _collectionSpecimenID;

    /**
     * keeps track of state for field: _collectionSpecimenID
    **/
    private boolean _has_collectionSpecimenID;

    /**
     * Calculated date, based on CollectionDay, -Month and -Year.
    **/
    private java.util.Date _collectionDate;

    /**
     * The day of the collection event.
    **/
    private int _collectionDay;

    /**
     * keeps track of state for field: _collectionDay
    **/
    private boolean _has_collectionDay;

    /**
     * The month of the collection event.
    **/
    private int _collectionMonth;

    /**
     * keeps track of state for field: _collectionMonth
    **/
    private boolean _has_collectionMonth;

    /**
     * The year of the collection event.
    **/
    private int _collectionYear;

    /**
     * keeps track of state for field: _collectionYear
    **/
    private boolean _has_collectionYear;

    /**
     * Verbal or additional date information, e.g. "end of summer
     * 1985".
    **/
    private java.lang.String _collectionDateSupplement;

    /**
     * Locality and geo-ecological description of the locality as
     * written on the original label.
    **/
    private java.lang.String _localityDescription;

    /**
     * Title of label if different from ExsiccataTitle for printing
     * labels. Will be printed on label after ExsiccataTitle.
    **/
    private java.lang.String _labelTitle;

    /**
     * Whether the label is typed, typed with hand written comments
     * of completely handwriting etc.
    **/
    private java.lang.String _labelType;

    /**
     * The path and file name of the scan of the label underneath
     * the folder where all labels are stored e.g.
     * "/Fungi/Erysiphales/M-0010/M-001034.jpg".
    **/
    private java.lang.String _labelScanPath;

    /**
     * The state of the transcription of a label into the database:
     * "Not started" / " incomplete" / "complete".
    **/
    private java.lang.String _labelTranscription;

    /**
     * User defined notes concerning the transcription of the label
     * into the database.
    **/
    private java.lang.String _labelTranscriptionNotes;

    /**
     * Accession number of the specimen within the collection, e.g.
     * "M-29834752".
    **/
    private java.lang.String _accessionNumber;

    /**
     * The date, when the specimen was taken in the collection
     * (format: YYYY/MM/DD).
    **/
    private java.lang.String _accessionDate;

    /**
     * Name of the Collection, e.g. "Botanische Staatssammlung
     * Mnchen".
    **/
    private java.lang.String _collectionName;

    /**
     * Standard abbreviation of the exsiccata.
    **/
    private java.lang.String _exsiccataTitle;

    /**
     * Number within the exsiccata.
    **/
    private java.lang.String _exsiccataNumber;

    /**
     * The name of the depositor resp. the herbarium if not the
     * original collector, e.g. "Herbarium P. Dbbler".
    **/
    private java.lang.String _depositorsName;

    /**
     * Accession number of the specimen within the herbarium where
     * the specimen came from if not the original collection, e.g.
     * "D-23948".
    **/
    private java.lang.String _depositorsAccessionNumber;

    /**
     * Notes given by the collector, resp. found on the label.
    **/
    private java.lang.String _originalNotes;

    /**
     * Additional notes made by the editor.
    **/
    private java.lang.String _additionalNotes;

    /**
     * Notes if the item is on loan resp. borrowed.
    **/
    private java.lang.String _loanInformation;

    /**
     * Problems found with the specimen, e.g. doubtful
     * identification, locality etc.
    **/
    private java.lang.String _problems;

    /**
     * Is set true if the label should be printed, is set false if
     * the label should not be printed.
    **/
    private boolean _printLabel;

    /**
     * keeps track of state for field: _printLabel
    **/
    private boolean _has_printLabel;


      //----------------/
     //- Constructors -/
    //----------------/

    public CollectionSpecimen() {
        super();
    } //-- net.metadiversity.diversity.navigator.db.ub.collection.CollectionSpecimen()


      //-----------/
     //- Methods -/
    //-----------/

    /**
    **/
    public void deleteCollectionDay()
    {
        this._has_collectionDay= false;
    } //-- void deleteCollectionDay() 

    /**
    **/
    public void deleteCollectionMonth()
    {
        this._has_collectionMonth= false;
    } //-- void deleteCollectionMonth() 

    /**
    **/
    public void deleteCollectionYear()
    {
        this._has_collectionYear= false;
    } //-- void deleteCollectionYear() 

    /**
    **/
    public void deletePrintLabel()
    {
        this._has_printLabel= false;
    } //-- void deletePrintLabel() 

    /**
     * Returns the value of field 'accessionDate'. The field
     * 'accessionDate' has the following description: The date,
     * when the specimen was taken in the collection (format:
     * YYYY/MM/DD).
     * 
     * @return the value of field 'accessionDate'.
    **/
    public java.lang.String getAccessionDate()
    {
        return this._accessionDate;
    } //-- java.lang.String getAccessionDate() 

    /**
     * Returns the value of field 'accessionNumber'. The field
     * 'accessionNumber' has the following description: Accession
     * number of the specimen within the collection, e.g.
     * "M-29834752".
     * 
     * @return the value of field 'accessionNumber'.
    **/
    public java.lang.String getAccessionNumber()
    {
        return this._accessionNumber;
    } //-- java.lang.String getAccessionNumber() 

    /**
     * Returns the value of field 'additionalNotes'. The field
     * 'additionalNotes' has the following description: Additional
     * notes made by the editor.
     * 
     * @return the value of field 'additionalNotes'.
    **/
    public java.lang.String getAdditionalNotes()
    {
        return this._additionalNotes;
    } //-- java.lang.String getAdditionalNotes() 

    /**
     * Returns the value of field 'collectionDate'. The field
     * 'collectionDate' has the following description: Calculated
     * date, based on CollectionDay, -Month and -Year.
     * 
     * @return the value of field 'collectionDate'.
    **/
    public java.util.Date getCollectionDate()
    {
        return this._collectionDate;
    } //-- java.util.Date getCollectionDate() 

    /**
     * Returns the value of field 'collectionDateSupplement'. The
     * field 'collectionDateSupplement' has the following
     * description: Verbal or additional date information, e.g.
     * "end of summer 1985".
     * 
     * @return the value of field 'collectionDateSupplement'.
    **/
    public java.lang.String getCollectionDateSupplement()
    {
        return this._collectionDateSupplement;
    } //-- java.lang.String getCollectionDateSupplement() 

    /**
     * Returns the value of field 'collectionDay'. The field
     * 'collectionDay' has the following description: The day of
     * the collection event.
     * 
     * @return the value of field 'collectionDay'.
    **/
    public int getCollectionDay()
    {
        return this._collectionDay;
    } //-- int getCollectionDay() 

    /**
     * Returns the value of field 'collectionMonth'. The field
     * 'collectionMonth' has the following description: The month
     * of the collection event.
     * 
     * @return the value of field 'collectionMonth'.
    **/
    public int getCollectionMonth()
    {
        return this._collectionMonth;
    } //-- int getCollectionMonth() 

    /**
     * Returns the value of field 'collectionName'. The field
     * 'collectionName' has the following description: Name of the
     * Collection, e.g. "Botanische Staatssammlung Mnchen".
     * 
     * @return the value of field 'collectionName'.
    **/
    public java.lang.String getCollectionName()
    {
        return this._collectionName;
    } //-- java.lang.String getCollectionName() 

    /**
     * Returns the value of field 'collectionSpecimenID'. The field
     * 'collectionSpecimenID' has the following description: Unique
     * reference ID for the collection record (primary key).
     * 
     * @return the value of field 'collectionSpecimenID'.
    **/
    public int getCollectionSpecimenID()
    {
        return this._collectionSpecimenID;
    } //-- int getCollectionSpecimenID() 

    /**
     * Returns the value of field 'collectionYear'. The field
     * 'collectionYear' has the following description: The year of
     * the collection event.
     * 
     * @return the value of field 'collectionYear'.
    **/
    public int getCollectionYear()
    {
        return this._collectionYear;
    } //-- int getCollectionYear() 

    /**
     * Returns the value of field 'depositorsAccessionNumber'. The
     * field 'depositorsAccessionNumber' has the following
     * description: Accession number of the specimen within the
     * herbarium where the specimen came from if not the original
     * collection, e.g. "D-23948".
     * 
     * @return the value of field 'depositorsAccessionNumber'.
    **/
    public java.lang.String getDepositorsAccessionNumber()
    {
        return this._depositorsAccessionNumber;
    } //-- java.lang.String getDepositorsAccessionNumber() 

    /**
     * Returns the value of field 'depositorsName'. The field
     * 'depositorsName' has the following description: The name of
     * the depositor resp. the herbarium if not the original
     * collector, e.g. "Herbarium P. Dbbler".
     * 
     * @return the value of field 'depositorsName'.
    **/
    public java.lang.String getDepositorsName()
    {
        return this._depositorsName;
    } //-- java.lang.String getDepositorsName() 

    /**
     * Returns the value of field 'exsiccataNumber'. The field
     * 'exsiccataNumber' has the following description: Number
     * within the exsiccata.
     * 
     * @return the value of field 'exsiccataNumber'.
    **/
    public java.lang.String getExsiccataNumber()
    {
        return this._exsiccataNumber;
    } //-- java.lang.String getExsiccataNumber() 

    /**
     * Returns the value of field 'exsiccataTitle'. The field
     * 'exsiccataTitle' has the following description: Standard
     * abbreviation of the exsiccata.
     * 
     * @return the value of field 'exsiccataTitle'.
    **/
    public java.lang.String getExsiccataTitle()
    {
        return this._exsiccataTitle;
    } //-- java.lang.String getExsiccataTitle() 

    /**
     * Returns the value of field 'labelScanPath'. The field
     * 'labelScanPath' has the following description: The path and
     * file name of the scan of the label underneath the folder
     * where all labels are stored e.g.
     * "/Fungi/Erysiphales/M-0010/M-001034.jpg".
     * 
     * @return the value of field 'labelScanPath'.
    **/
    public java.lang.String getLabelScanPath()
    {
        return this._labelScanPath;
    } //-- java.lang.String getLabelScanPath() 

    /**
     * Returns the value of field 'labelTitle'. The field
     * 'labelTitle' has the following description: Title of label
     * if different from ExsiccataTitle for printing labels. Will
     * be printed on label after ExsiccataTitle.
     * 
     * @return the value of field 'labelTitle'.
    **/
    public java.lang.String getLabelTitle()
    {
        return this._labelTitle;
    } //-- java.lang.String getLabelTitle() 

    /**
     * Returns the value of field 'labelTranscription'. The field
     * 'labelTranscription' has the following description: The
     * state of the transcription of a label into the database:
     * "Not started" / " incomplete" / "complete".
     * 
     * @return the value of field 'labelTranscription'.
    **/
    public java.lang.String getLabelTranscription()
    {
        return this._labelTranscription;
    } //-- java.lang.String getLabelTranscription() 

    /**
     * Returns the value of field 'labelTranscriptionNotes'. The
     * field 'labelTranscriptionNotes' has the following
     * description: User defined notes concerning the transcription
     * of the label into the database.
     * 
     * @return the value of field 'labelTranscriptionNotes'.
    **/
    public java.lang.String getLabelTranscriptionNotes()
    {
        return this._labelTranscriptionNotes;
    } //-- java.lang.String getLabelTranscriptionNotes() 

    /**
     * Returns the value of field 'labelType'. The field
     * 'labelType' has the following description: Whether the label
     * is typed, typed with hand written comments of completely
     * handwriting etc.
     * 
     * @return the value of field 'labelType'.
    **/
    public java.lang.String getLabelType()
    {
        return this._labelType;
    } //-- java.lang.String getLabelType() 

    /**
     * Returns the value of field 'loanInformation'. The field
     * 'loanInformation' has the following description: Notes if
     * the item is on loan resp. borrowed.
     * 
     * @return the value of field 'loanInformation'.
    **/
    public java.lang.String getLoanInformation()
    {
        return this._loanInformation;
    } //-- java.lang.String getLoanInformation() 

    /**
     * Returns the value of field 'localityDescription'. The field
     * 'localityDescription' has the following description:
     * Locality and geo-ecological description of the locality as
     * written on the original label.
     * 
     * @return the value of field 'localityDescription'.
    **/
    public java.lang.String getLocalityDescription()
    {
        return this._localityDescription;
    } //-- java.lang.String getLocalityDescription() 

    /**
     * Returns the value of field 'originalNotes'. The field
     * 'originalNotes' has the following description: Notes given
     * by the collector, resp. found on the label.
     * 
     * @return the value of field 'originalNotes'.
    **/
    public java.lang.String getOriginalNotes()
    {
        return this._originalNotes;
    } //-- java.lang.String getOriginalNotes() 

    /**
     * Returns the value of field 'printLabel'. The field
     * 'printLabel' has the following description: Is set true if
     * the label should be printed, is set false if the label
     * should not be printed.
     * 
     * @return the value of field 'printLabel'.
    **/
    public boolean getPrintLabel()
    {
        return this._printLabel;
    } //-- boolean getPrintLabel() 

    /**
     * Returns the value of field 'problems'. The field 'problems'
     * has the following description: Problems found with the
     * specimen, e.g. doubtful identification, locality etc.
     * 
     * @return the value of field 'problems'.
    **/
    public java.lang.String getProblems()
    {
        return this._problems;
    } //-- java.lang.String getProblems() 

    /**
    **/
    public boolean hasCollectionDay()
    {
        return this._has_collectionDay;
    } //-- boolean hasCollectionDay() 

    /**
    **/
    public boolean hasCollectionMonth()
    {
        return this._has_collectionMonth;
    } //-- boolean hasCollectionMonth() 

    /**
    **/
    public boolean hasCollectionSpecimenID()
    {
        return this._has_collectionSpecimenID;
    } //-- boolean hasCollectionSpecimenID() 

    /**
    **/
    public boolean hasCollectionYear()
    {
        return this._has_collectionYear;
    } //-- boolean hasCollectionYear() 

    /**
    **/
    public boolean hasPrintLabel()
    {
        return this._has_printLabel;
    } //-- boolean hasPrintLabel() 

    /**
    **/
    public boolean isValid()
    {
        try {
            validate();
        }
        catch (org.exolab.castor.xml.ValidationException vex) {
            return false;
        }
        return true;
    } //-- boolean isValid() 

    /**
     * 
     * 
     * @param out
    **/
    public abstract void marshal(java.io.Writer out)
        throws org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException;

    /**
     * 
     * 
     * @param handler
    **/
    public abstract void marshal(org.xml.sax.ContentHandler handler)
        throws java.io.IOException, org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException;

    /**
     * Sets the value of field 'accessionDate'. The field
     * 'accessionDate' has the following description: The date,
     * when the specimen was taken in the collection (format:
     * YYYY/MM/DD).
     * 
     * @param accessionDate the value of field 'accessionDate'.
    **/
    public void setAccessionDate(java.lang.String accessionDate)
    {
        this._accessionDate = accessionDate;
    } //-- void setAccessionDate(java.lang.String) 

    /**
     * Sets the value of field 'accessionNumber'. The field
     * 'accessionNumber' has the following description: Accession
     * number of the specimen within the collection, e.g.
     * "M-29834752".
     * 
     * @param accessionNumber the value of field 'accessionNumber'.
    **/
    public void setAccessionNumber(java.lang.String accessionNumber)
    {
        this._accessionNumber = accessionNumber;
    } //-- void setAccessionNumber(java.lang.String) 

    /**
     * Sets the value of field 'additionalNotes'. The field
     * 'additionalNotes' has the following description: Additional
     * notes made by the editor.
     * 
     * @param additionalNotes the value of field 'additionalNotes'.
    **/
    public void setAdditionalNotes(java.lang.String additionalNotes)
    {
        this._additionalNotes = additionalNotes;
    } //-- void setAdditionalNotes(java.lang.String) 

    /**
     * Sets the value of field 'collectionDate'. The field
     * 'collectionDate' has the following description: Calculated
     * date, based on CollectionDay, -Month and -Year.
     * 
     * @param collectionDate the value of field 'collectionDate'.
    **/
    public void setCollectionDate(java.util.Date collectionDate)
    {
        this._collectionDate = collectionDate;
    } //-- void setCollectionDate(java.util.Date) 

    /**
     * Sets the value of field 'collectionDateSupplement'. The
     * field 'collectionDateSupplement' has the following
     * description: Verbal or additional date information, e.g.
     * "end of summer 1985".
     * 
     * @param collectionDateSupplement the value of field
     * 'collectionDateSupplement'.
    **/
    public void setCollectionDateSupplement(java.lang.String collectionDateSupplement)
    {
        this._collectionDateSupplement = collectionDateSupplement;
    } //-- void setCollectionDateSupplement(java.lang.String) 

    /**
     * Sets the value of field 'collectionDay'. The field
     * 'collectionDay' has the following description: The day of
     * the collection event.
     * 
     * @param collectionDay the value of field 'collectionDay'.
    **/
    public void setCollectionDay(int collectionDay)
    {
        this._collectionDay = collectionDay;
        this._has_collectionDay = true;
    } //-- void setCollectionDay(int) 

    /**
     * Sets the value of field 'collectionMonth'. The field
     * 'collectionMonth' has the following description: The month
     * of the collection event.
     * 
     * @param collectionMonth the value of field 'collectionMonth'.
    **/
    public void setCollectionMonth(int collectionMonth)
    {
        this._collectionMonth = collectionMonth;
        this._has_collectionMonth = true;
    } //-- void setCollectionMonth(int) 

    /**
     * Sets the value of field 'collectionName'. The field
     * 'collectionName' has the following description: Name of the
     * Collection, e.g. "Botanische Staatssammlung Mnchen".
     * 
     * @param collectionName the value of field 'collectionName'.
    **/
    public void setCollectionName(java.lang.String collectionName)
    {
        this._collectionName = collectionName;
    } //-- void setCollectionName(java.lang.String) 

    /**
     * Sets the value of field 'collectionSpecimenID'. The field
     * 'collectionSpecimenID' has the following description: Unique
     * reference ID for the collection record (primary key).
     * 
     * @param collectionSpecimenID the value of field
     * 'collectionSpecimenID'.
    **/
    public void setCollectionSpecimenID(int collectionSpecimenID)
    {
        this._collectionSpecimenID = collectionSpecimenID;
        this._has_collectionSpecimenID = true;
    } //-- void setCollectionSpecimenID(int) 

    /**
     * Sets the value of field 'collectionYear'. The field
     * 'collectionYear' has the following description: The year of
     * the collection event.
     * 
     * @param collectionYear the value of field 'collectionYear'.
    **/
    public void setCollectionYear(int collectionYear)
    {
        this._collectionYear = collectionYear;
        this._has_collectionYear = true;
    } //-- void setCollectionYear(int) 

    /**
     * Sets the value of field 'depositorsAccessionNumber'. The
     * field 'depositorsAccessionNumber' has the following
     * description: Accession number of the specimen within the
     * herbarium where the specimen came from if not the original
     * collection, e.g. "D-23948".
     * 
     * @param depositorsAccessionNumber the value of field
     * 'depositorsAccessionNumber'.
    **/
    public void setDepositorsAccessionNumber(java.lang.String depositorsAccessionNumber)
    {
        this._depositorsAccessionNumber = depositorsAccessionNumber;
    } //-- void setDepositorsAccessionNumber(java.lang.String) 

    /**
     * Sets the value of field 'depositorsName'. The field
     * 'depositorsName' has the following description: The name of
     * the depositor resp. the herbarium if not the original
     * collector, e.g. "Herbarium P. Dbbler".
     * 
     * @param depositorsName the value of field 'depositorsName'.
    **/
    public void setDepositorsName(java.lang.String depositorsName)
    {
        this._depositorsName = depositorsName;
    } //-- void setDepositorsName(java.lang.String) 

    /**
     * Sets the value of field 'exsiccataNumber'. The field
     * 'exsiccataNumber' has the following description: Number
     * within the exsiccata.
     * 
     * @param exsiccataNumber the value of field 'exsiccataNumber'.
    **/
    public void setExsiccataNumber(java.lang.String exsiccataNumber)
    {
        this._exsiccataNumber = exsiccataNumber;
    } //-- void setExsiccataNumber(java.lang.String) 

    /**
     * Sets the value of field 'exsiccataTitle'. The field
     * 'exsiccataTitle' has the following description: Standard
     * abbreviation of the exsiccata.
     * 
     * @param exsiccataTitle the value of field 'exsiccataTitle'.
    **/
    public void setExsiccataTitle(java.lang.String exsiccataTitle)
    {
        this._exsiccataTitle = exsiccataTitle;
    } //-- void setExsiccataTitle(java.lang.String) 

    /**
     * Sets the value of field 'labelScanPath'. The field
     * 'labelScanPath' has the following description: The path and
     * file name of the scan of the label underneath the folder
     * where all labels are stored e.g.
     * "/Fungi/Erysiphales/M-0010/M-001034.jpg".
     * 
     * @param labelScanPath the value of field 'labelScanPath'.
    **/
    public void setLabelScanPath(java.lang.String labelScanPath)
    {
        this._labelScanPath = labelScanPath;
    } //-- void setLabelScanPath(java.lang.String) 

    /**
     * Sets the value of field 'labelTitle'. The field 'labelTitle'
     * has the following description: Title of label if different
     * from ExsiccataTitle for printing labels. Will be printed on
     * label after ExsiccataTitle.
     * 
     * @param labelTitle the value of field 'labelTitle'.
    **/
    public void setLabelTitle(java.lang.String labelTitle)
    {
        this._labelTitle = labelTitle;
    } //-- void setLabelTitle(java.lang.String) 

    /**
     * Sets the value of field 'labelTranscription'. The field
     * 'labelTranscription' has the following description: The
     * state of the transcription of a label into the database:
     * "Not started" / " incomplete" / "complete".
     * 
     * @param labelTranscription the value of field
     * 'labelTranscription'.
    **/
    public void setLabelTranscription(java.lang.String labelTranscription)
    {
        this._labelTranscription = labelTranscription;
    } //-- void setLabelTranscription(java.lang.String) 

    /**
     * Sets the value of field 'labelTranscriptionNotes'. The field
     * 'labelTranscriptionNotes' has the following description:
     * User defined notes concerning the transcription of the label
     * into the database.
     * 
     * @param labelTranscriptionNotes the value of field
     * 'labelTranscriptionNotes'.
    **/
    public void setLabelTranscriptionNotes(java.lang.String labelTranscriptionNotes)
    {
        this._labelTranscriptionNotes = labelTranscriptionNotes;
    } //-- void setLabelTranscriptionNotes(java.lang.String) 

    /**
     * Sets the value of field 'labelType'. The field 'labelType'
     * has the following description: Whether the label is typed,
     * typed with hand written comments of completely handwriting
     * etc.
     * 
     * @param labelType the value of field 'labelType'.
    **/
    public void setLabelType(java.lang.String labelType)
    {
        this._labelType = labelType;
    } //-- void setLabelType(java.lang.String) 

    /**
     * Sets the value of field 'loanInformation'. The field
     * 'loanInformation' has the following description: Notes if
     * the item is on loan resp. borrowed.
     * 
     * @param loanInformation the value of field 'loanInformation'.
    **/
    public void setLoanInformation(java.lang.String loanInformation)
    {
        this._loanInformation = loanInformation;
    } //-- void setLoanInformation(java.lang.String) 

    /**
     * Sets the value of field 'localityDescription'. The field
     * 'localityDescription' has the following description:
     * Locality and geo-ecological description of the locality as
     * written on the original label.
     * 
     * @param localityDescription the value of field
     * 'localityDescription'.
    **/
    public void setLocalityDescription(java.lang.String localityDescription)
    {
        this._localityDescription = localityDescription;
    } //-- void setLocalityDescription(java.lang.String) 

    /**
     * Sets the value of field 'originalNotes'. The field
     * 'originalNotes' has the following description: Notes given
     * by the collector, resp. found on the label.
     * 
     * @param originalNotes the value of field 'originalNotes'.
    **/
    public void setOriginalNotes(java.lang.String originalNotes)
    {
        this._originalNotes = originalNotes;
    } //-- void setOriginalNotes(java.lang.String) 

    /**
     * Sets the value of field 'printLabel'. The field 'printLabel'
     * has the following description: Is set true if the label
     * should be printed, is set false if the label should not be
     * printed.
     * 
     * @param printLabel the value of field 'printLabel'.
    **/
    public void setPrintLabel(boolean printLabel)
    {
        this._printLabel = printLabel;
        this._has_printLabel = true;
    } //-- void setPrintLabel(boolean) 

    /**
     * Sets the value of field 'problems'. The field 'problems' has
     * the following description: Problems found with the specimen,
     * e.g. doubtful identification, locality etc.
     * 
     * @param problems the value of field 'problems'.
    **/
    public void setProblems(java.lang.String problems)
    {
        this._problems = problems;
    } //-- void setProblems(java.lang.String) 

    /**
    **/
    public void validate()
        throws org.exolab.castor.xml.ValidationException
    {
        org.exolab.castor.xml.Validator validator = new org.exolab.castor.xml.Validator();
        validator.validate(this);
    } //-- void validate() 

}
