/*
 * QueryFrame.java
 *
 * Created on 20. Juli 2003, 16:08
 */
package net.metadiversity.diversity.navigator.gui;


import org.apache.log4j.Logger;
import org.apache.log4j.Priority;
import org.apache.log4j.Level;

import net.metadiversity.diversity.navigator.project.*;
/**
 *
 * @author  didi
 */
public class QueryFrame extends javax.swing.JFrame 
{
    static Logger logger = Logger.getLogger( QueryFrame.class.getName() ); 
    
    int size;
    
    DnDbProjectRoot projectRoot;
    DnDbProject     project_1, project_2;
    DnDbGroup       group_1, group_2;
    DnDatabase      database_1, database_2;
    
    
    /** Creates new form QueryFrame */
    public QueryFrame() 
    {
        org.apache.log4j.BasicConfigurator.configure();
        // deprecated logger.setPriority( Priority.DEBUG );
        logger.setLevel( Level.DEBUG );
        // logger.addAppender( new org.apache.log4j.ConsoleAppender() );
        logger.debug( "TextQuery()" );
        try
        {
            projectRoot = new DnDbProjectRoot();
            
            project_1     = new DnDbProject( "project" );
            group_1       = new DnDbGroup( "group" );
            database_1    = new DnDatabase( "Checklists" );
            group_1.addDnDatabase( database_1 );
            project_1.addDnGroup( group_1 );

            project_2     = new DnDbProject( "project-2" );
            group_2       = new DnDbGroup( "group-2" );
            database_2    = new DnDatabase( "Checklists" );
            group_2.addDnDatabase( database_2 );
            project_2.addDnGroup( group_2 );
            
            projectRoot.addDnProject( project_1 );
            projectRoot.addDnProject( project_2 );
        }
        catch( Exception ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }
        
        size = 0;
        initComponents();
        setSize( 400, 400 );
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents()//GEN-BEGIN:initComponents
    {
        jLabel1 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jSplitPane1 = new javax.swing.JSplitPane();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTree2 = new javax.swing.JTree();
        jScrollPane4 = new javax.swing.JScrollPane();
        queryPanal = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        jLabel2 = new javax.swing.JLabel();

        addWindowListener(new java.awt.event.WindowAdapter()
        {
            public void windowClosing(java.awt.event.WindowEvent evt)
            {
                exitForm(evt);
            }
        });

        jLabel1.setText("Query");
        getContentPane().add(jLabel1, java.awt.BorderLayout.NORTH);

        jButton1.setText("Add Query Entry");
        jButton1.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                jButton1ActionPerformed(evt);
            }
        });

        getContentPane().add(jButton1, java.awt.BorderLayout.SOUTH);

        jTree2.setModel(new QueryTreeModel( projectRoot ) );
        jScrollPane3.setViewportView(jTree2);

        jSplitPane1.setLeftComponent(jScrollPane3);

        queryPanal.setLayout(new javax.swing.BoxLayout(queryPanal, javax.swing.BoxLayout.Y_AXIS));

        queryPanal.setName("queryPanel");
        queryPanal.setAutoscrolls(true);
        queryPanal.add(jScrollPane2);

        jScrollPane4.setViewportView(queryPanal);

        jSplitPane1.setRightComponent(jScrollPane4);

        getContentPane().add(jSplitPane1, java.awt.BorderLayout.CENTER);

        jLabel2.setIcon(new javax.swing.JLabel()
        {
            public javax.swing.Icon getIcon()
            {
                try
                {
                    return new javax.swing.ImageIcon(
                        new java.net.URL("http://localhost/icons/test.png")
                    );
                } catch (java.net.MalformedURLException e)
                {
                }
                return null;
            }
        }.getIcon());
        jLabel2.setAutoscrolls(true);
        jScrollPane1.setViewportView(jLabel2);

        getContentPane().add(jScrollPane1, java.awt.BorderLayout.EAST);

        pack();
    }//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed

        
        size += 50;
        int i = javax.swing.JOptionPane.showInternalConfirmDialog( getContentPane(), "Add new entry" );
        if( i == 0 )
        {    
            // queryPanal.setSize( new java.awt.Dimension( size, 200 ) );
            
            queryPanal.add( new BasicQueryField( "table " + size, "col " + size ) );
        }
/*        
        DnOptionDialog d = new DnOptionDialog( getContentPane() );
        int i = d.showConfirmDialog( "Add to query" );
        if( i == 0 )
        {    
            queryPanal.setSize( new java.awt.Dimension( 100, size ) );
            queryPanal.add( new BasicQueryPanel("table", "col", size ) );
        }
 */
        // pack();
        show();
        // show an internal dialog
        
    }//GEN-LAST:event_jButton1ActionPerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) 
    {
        new QueryFrame().show();
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JButton jButton1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTree jTree2;
    private javax.swing.JPanel queryPanal;
    private javax.swing.JScrollPane jScrollPane3;
    // End of variables declaration//GEN-END:variables
    
}
