/*
 * QueryTreeModel.java
 *
 * Created on 29. Juli 2003, 12:29
 */

package net.metadiversity.diversity.navigator.gui;

import net.metadiversity.diversity.navigator.project.*;

import org.apache.log4j.Logger;


/**
 *
 * @author  Dieter Neubacher
 */
public class QueryTreeModel implements javax.swing.tree.TreeModel
{
    static Logger logger = Logger.getLogger( QueryTreeModel.class.getName() );
    
    private DnDbProjectRoot projectRoot;
    private javax.swing.event.EventListenerList listenerList;
            
    /** Creates a new instance of QueryTreeModel */
    public QueryTreeModel( DnDbProjectRoot root )
    {
        if( logger.isDebugEnabled() ) logger.debug( "QueryTreeModel()" ); 
        projectRoot = root;
        listenerList = new javax.swing.event.EventListenerList();
    }
    
    public void addTreeModelListener( javax.swing.event.TreeModelListener treeModelListener )
    {
        listenerList.add( javax.swing.event.TreeModelListener.class, treeModelListener );
    }
    
    public Object getChild( Object parent, int param )
    {
        if( logger.isDebugEnabled() ) logger.debug( "getChild( " + parent + ", " + param + " )" );

         return projectRoot.getChild( (java.lang.String) parent, param );
/*        
        if( parent.toString().compareTo( "root" ) == 0 ) 
        {
            return parent.toString() + "." + projectRoot.getChild( param );
        }
        else
        {
            return "getChild";
        }    
 */
    }
    
    public int getChildCount( Object parent )
    {
         if( logger.isDebugEnabled() ) logger.debug( "getChildCount( " + parent + " )" );
         
         return projectRoot.getChildCount( (java.lang.String) parent );
    }
    
    public int getIndexOfChild( Object parent, Object child )
    {
        if( logger.isDebugEnabled() ) logger.debug( "getChild( " + parent + ", " + child + " )" );
         
        return 1;
    }
    
    public Object getRoot()
    {
        return "root";
    }
    
    public boolean isLeaf( Object node )
    {
        if( logger.isDebugEnabled() ) logger.debug( "isLeaf( " + node + ")" );
        
        int level = 0;
        int pos = 0;
        java.lang.String str = node.toString();
        while( ( pos = str.indexOf( '.' ) ) > 0 )
        {
            if( logger.isDebugEnabled() ) logger.debug( "str: " + str );
            level++;
            str = str.substring( ++pos );
        }    
        return false;
    }
    
    public void removeTreeModelListener(javax.swing.event.TreeModelListener treeModelListener)
    {
    }
    
    public void valueForPathChanged(javax.swing.tree.TreePath treePath, Object obj)
    {
    }    
}
