/*
 * ErrorMessage.java
 *
 * Created on 14. Mai 2002, 17:02
 */

package net.metadiversity.diversity.navigator.message;

import org.apache.log4j.*;
/**
 *
 * @author didi
 */
public class ErrorMessage extends javax.swing.JDialog 
{
    static Logger logger = Logger.getLogger( ErrorMessage.class.getName() );
    /** A return status code - returned if Cancel button has been pressed */
    public static final int RET_CANCEL = 0;
    /** A return status code - returned if OK button has been pressed */
    public static final int RET_OK = 1;

    /** Creates new form ErrorMessage */
    public ErrorMessage( java.awt.Frame parent, boolean modal ) 
    {
        super( parent, modal );
	setErrorMessageText( "Error text ..." );
        initComponents();
    }

    public ErrorMessage( java.awt.Frame parent, boolean modal, java.lang.String errorText ) 
    {
        super( parent, modal );
	setErrorMessageText( errorText );
        initComponents();
    }

    public void setErrorMessageText( java.lang.String msg )
    {
	errorMessageText = msg;
    }


    /** @return the return status of this dialog - one of RET_OK or RET_CANCEL */
    public int getReturnStatus() 
    {
        return returnStatus;
    }
    private void initComponents() 
    {
        buttonPanel       = new javax.swing.JPanel();
        okButton          = new javax.swing.JButton();
        errorMessageLabel = new java.awt.Label();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        okButton.setText( "OK" );
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        buttonPanel.add(okButton);

        getContentPane().add(buttonPanel, java.awt.BorderLayout.SOUTH);

        errorMessageLabel.setName( "errorMessageText" );
        errorMessageLabel.setText( errorMessageText );
        errorMessageLabel.setAlignment(java.awt.Label.CENTER);
        getContentPane().add(errorMessageLabel, java.awt.BorderLayout.CENTER);

        pack();
    }

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) 
    {
        doClose( RET_OK );
    }

    /** Closes the dialog */
    private void closeDialog( java.awt.event.WindowEvent evt ) 
    {
        doClose( RET_CANCEL );
    }

    private void doClose( int retStatus ) 
    {
        returnStatus = retStatus;
        setVisible( false );
        dispose();
    }

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) 
    {
        new ErrorMessage( new javax.swing.JFrame(), true, "The error message...." ).show();
    }

    // Variables declaration

    private javax.swing.JPanel  buttonPanel;
    private javax.swing.JButton okButton;
    private java.awt.Label      errorMessageLabel;

    private java.lang.String    errorMessageText;
    // End of variables 

    private int returnStatus = RET_CANCEL;
}
